//+--------------------------------------------------------------------------+
//|                                                      mv-e-DailyRange.mq4 |
//|                                                 . MaxV42 |
//|                                               http://                    |
//|  H1.                                                            |
//|  1.0:                                                              |
//+--------------------------------------------------------------------------+
#property copyright "  . MaxV42"
#property link      "http://"
//+------------------------------------------------------------------+
#include <b-Positions.mqh>       //      .  (  .)
#include <b-Orders.mqh>          //      .   (  .)
#include <b-Lots.mqh>            //     .    (  .)
//+------------------------------------------------------------------+
//    
extern string Exp_Coment1= "---    ---";
extern int MagicNumber     =  12345;           // MagicNumber
extern bool UseTrailing    =  false;           //  
extern bool Use.Buy        =   true;           //   
extern bool Use.Sell       =   true;           //   
extern int DailyRange.Buy  =    100;           //      High[0]    Buy
extern int DailyRange.Sell =    138;           //      Low[0]    Sell

extern int SessionTrade.Begin  = 21;               //   
extern int SessionTrade.Finish = 21;               //   
extern bool Use.SessionFilter    =   true;         // /   

extern string Exp_Coment2= "0- , 1- 1-st Level Stop/Reverse  1-st Level Stop/Reverse";
extern int Trailing.Type   =      0;           // 0 -  , 1 -  "1-st Level Stop/Reverse"  "1-st Level Stop/Reverse"
extern string Exp_Coment3= "0-StopLoss  TakeProfit  ";
extern int StopLoss.Buy    =     86;           //    
extern int TakeProf.Buy    =    130;           //    
extern int StopLoss.Sell   =    142;           //    
extern int TakeProf.Sell   =    146;           //    
//+------------------------------------------------------------------+
//   
int nBars=0;
//+------------------------------------------------------------------+
int init()  {     // expert initialization function
   return(0);
}

//+------------------------------------------------------------------+
int deinit()  {   // expert deinitialization function
   return(0);
}

//+------------------------------------------------------------------+
int start() {     // expert start function
  //    
  if(!isNewBar()) return;
  // -----  
  Trade(Criterion());
  return(0);
}

//+------------------------------------------------------------------+
int Criterion() {  //    .
bool IsOpenBuy =ExistPositions(NULL, OP_BUY, MagicNumber, 0);     //    Buy-
bool IsOpenSell=ExistPositions(NULL, OP_SELL, MagicNumber, 0);    //    Sell-
datetime dSessionTrade.Begin=StrToTime(TimeToStr(Time[0],TIME_DATE)+" "+DoubleToStr(SessionTrade.Begin,0)+":00");
datetime dSessionTrade.Finish=StrToTime(TimeToStr(Time[0],TIME_DATE)+" "+DoubleToStr(SessionTrade.Finish,0)+":00");

  //--------------------------------------------------------- 1 --

  //   
  if(Use.Buy && !IsOpenBuy &&                                                               //
     (iHigh(Symbol(),PERIOD_D1,0)-MarketInfo(Symbol(),MODE_ASK))/Point>DailyRange.Buy)  {   //  
    // -----      
    if(!Use.SessionFilter) return(10);
    // -----     
    if(Time[0]>=dSessionTrade.Begin && Time[0]<=dSessionTrade.Finish)  {
      return(10);
    }
  }
  //    Buy  
  if( IsOpenBuy && DistMarketAndPos(NULL, OP_BUY, MagicNumber)<=StopLoss.Buy*(-1) && StopLoss.Buy>0 )
    return(11);
  //    Buy  
  if( IsOpenBuy && DistMarketAndPos(NULL, OP_BUY, MagicNumber)>=TakeProf.Buy && TakeProf.Buy>0 )
    return(11);
  //--------------------------------------------------------- 2 --
  //   
  if(Use.Sell && !IsOpenSell &&                                                             // 
     (MarketInfo(Symbol(),MODE_BID)-iLow(Symbol(),PERIOD_D1,0))/Point>DailyRange.Sell)  {   //  
    // -----      
    if(!Use.SessionFilter) return(20);
    // -----     
    if(Time[0]>=dSessionTrade.Begin && Time[0]<=dSessionTrade.Finish)  {
      return(20);
    }
  }
  //    Sell  
  if( IsOpenSell && DistMarketAndPos(NULL, OP_SELL, MagicNumber)<=StopLoss.Sell*(-1) && StopLoss.Sell>0 )
    return(21);
  //    Sell  
  if( IsOpenSell && DistMarketAndPos(NULL, OP_SELL, MagicNumber)>=TakeProf.Sell && TakeProf.Sell>0 )
    return(21);

  return(0);
}

void Trade(int TradeSignal)  { //  
  // TradeSignal -   :
  // 10 -  Buy  
  // 20 -  Sell 
  // 11 -  Buy
  // 21 -  Sell
  //  0 -   

bool IsOpenBuy =ExistPositions(NULL, OP_BUY, MagicNumber, 0);     //    Buy-
bool IsOpenSell=ExistPositions(NULL, OP_SELL, MagicNumber, 0);    //    Sell-
  switch(TradeSignal) {

    //--------------------------------------------------------- 1 --
    case 10:                                                                //   = Buy
      if(IsOpenSell) ClosePosFirstProfit(NULL, OP_SELL, MagicNumber);       //   Sell
      OpenPosition(NULL, OP_BUY, GetSizeLot(), 0, 0, MagicNumber, "");      //  Buy
      break;                                                                //  - 
    //--------------------------------------------------------- 2 --
    case 11:                                                                // . . =  Buy
      ClosePosFirstProfit(NULL, OP_BUY, MagicNumber);                       //   Buy
      break;                                                                //  - 
    //--------------------------------------------------------- 2 --
    case 20:                                                                //   = Sell
      if(IsOpenBuy) ClosePosFirstProfit(NULL, OP_BUY, MagicNumber);         //   Buy
      OpenPosition(NULL, OP_SELL, GetSizeLot(), 0, 0, MagicNumber, "");     //  Sell
      break;                                                                //  - 
    //--------------------------------------------------------- 4 --
    case 21:                                                                // . . =  Sell
      ClosePosFirstProfit(NULL, OP_SELL, MagicNumber);                      //   Sell
      break;                                                                //  - 
    //--------------------------------------------------------- 5 --
    case 0:                                                                 //   
      if(IsOpenSell || IsOpenBuy)  {
        if(UseTrailing)  {
          if(Trailing.Type==0) SimpleTrailing(NULL, -1, MagicNumber);       //   
        }
      }
      break;                                                               //  - 
  }

  return;
}

//+---------------------------------------------------------------------------+
bool isNewBar() {                     //   true,    ,  false
  if(nBars!=Bars) {
    nBars=Bars; return(true);
  }
  return(false);
}